// Project: DEMO - proposed name: <Silent Simplexity>


#include "fs3de.cpp"
#include "demo.hpp"
//#include <iostream.h>
#include <conio.h>
#include "lists.hpp"
#include "stars.cpp"
#include "orgvoxel.cpp"
//#include "fs3d.cpp"
	 void ScreenSpace_t::Draw(){}


#define SIMPLEXITY_VERSION	"0.0000"
#define SIMPLEXITY_DATE			"25/03-1997"

void FadeScreenToBlack(){
	Palette pal;
	pal.GetCurrent();
	boolean done=FALSE;
	do//for(int i=0;i<63;i++)
	{ done=TRUE;
		for(int j=0;j<256*3;j++)
		{
			if(pal.PalRaw[j]){
				if(--pal.PalRaw[j]) --pal.PalRaw[j];
				done=FALSE;
			}
		}
		pal.Set();
		x_wait_vsync();
	}while(!done);
}

boolean ExecuteMain(){
	Sky = new StarField_t(400, FallOffDistance, 0, 63);
	Sky->Movement=vector3D(0,0,3);

	if(SetDemoGraphicMode(DGM_ModeX))
	{
		for(int i=0;i<64;i++){
			x_set_rgb(i,i,i,i); //White
			x_set_rgb(i+64,i,0,0);
			x_set_rgb(i+2*64,0,i,0);
			x_set_rgb(i+3*64,0,0,i);
		}
		//getch();
		Sky->Rotation=rotation3D_t(0,0,-5);
		//CubeX();

		Sky->Rotation=rotation3D_t(0,0,+5);
		OrganicVoxel_X();
	}
	return TRUE;
}

boolean Initialise(){
	clrscr();
	cout<<"  -+* (Silent) Simplexity v"<<SIMPLEXITY_VERSION<<" *+- \n";
	OriginalPalette.GetCurrent();
	//FadeScreenToBlack();
	Math3D_SetUp_SineTable(); //Cos and Sine
	/*x_set_mode(X_MODE_320x240,320); //320x400 max res, w/2 pages(256kB limit)
	x_set_doublebuffer(ScrnPhysicalHeight);
	PageScr[0] = Page0_Offs;		 PageScr[1] = Page1_Offs;*/
	SetDemoGraphicMode(DGM_ModeX);
	//MyFS3DE = new FlatShading3DEngine();
	//ScreenCenterPoint =  point2D_t(ScrnPhysicalPixelWidth>>1, ScrnPhysicalHeight>>1);

	x_text_init();

	return TRUE;
}

boolean CleanUp(){
	SetDemoGraphicMode(DGM_TextMode);
	OriginalPalette.Set();
	return TRUE;
}

void main(int argc, char* argv[])
{
	//TEXTmain();
	Initialise();

	ExecuteMain();

	CleanUp();

}



