
FlatShading3DEngine *MyFS3DE;

void ScreenSpace_t::Draw(){
	point2D_t p, sp[3];
	F2DL->ResetStart();
	if(F2DL->NumOfElems())
	do{
		sp[0]=SCL->operator[](F2DL->Current().fp[0]);
		sp[1]=SCL->operator[](F2DL->Current().fp[1]);
		sp[2]=SCL->operator[](F2DL->Current().fp[2]);

		x_triangle(sp[0].V(0), sp[0].V(1),
							 sp[1].V(0), sp[1].V(1),
							 sp[2].V(0), sp[2].V(1),
							 F2DL->Current().color, LogicalScr	);
	 /*							SCL->[F2DL->Current().fp[0].v(0),

		int x0, int y0, int x1, int y1, int x2, int y2,
				 WORD color, WORD PageBase);  */

	}while(++(*F2DL));

	/*
	SCL->ResetStart();
	do{
		p=SCL->Current();/* + point2D_t(ScrnPhysicalPixelWidth>>1,
											ScrnPhysicalHeight>>1);
		if( (unsigned int) p.V(0)<ScrnPhysicalPixelWidth
				&& (unsigned int) p.V(1)<ScrnPhysicalHeight)
					x_put_pix(p.V(0),p.V(1),LogicalScr,63);
	}while(++(*SCL));
	*/
}

#define num_vertex 512
/*class SortVL {
	public:
		ListIndex_t I;				FP_type Z;
		SortVL() : I(0), Z(0) {};
		SortVL(ListIndex_t i, FP_type z) : I(i), Z(z) {};
		inline boolean operator >(SortVL VL2){ return (Z>VL2.Z ? TRUE : FALSE ); }
};*/
//Main loop
void CubeX(){
	Position6D_t Observer, ObjPos, ObjPos2;
	FaceList MyFL(num_vertex); NormalList MyNL(num_vertex);
	VertexList VL(num_vertex);
	ObjPos.Pos=ObjPos.Pos+point_t(0,0,30);
	ObjPos2.Pos=ObjPos2.Pos+point_t(20,0,40);
	SimpleObjData My3DObj(&VL, &MyNL, &MyFL);
	ObjPos.Pos=ObjPos.Pos+point_t(0,0,1000);

	char ch;

	pMatrix_t ObjMatrix;
	point_t P;
	VL.EmptyList();		MyNL.EmptyList();  MyFL.EmptyList();
	VL.Add(point_t(-5,-5,-5));//0    0-1
	VL.Add(point_t( 5,-5,-5));//1    |/|
	VL.Add(point_t(-5, 5,-5));//2    2-3   4---5
	VL.Add(point_t( 5, 5,-5));//3     \   |  /|
	VL.Add(point_t(-5,-5,5));//4         \ |/  |
	VL.Add(point_t( 5,-5,5));//5           6---7
	VL.Add(point_t(-5, 5,5));//6
	VL.Add(point_t( 5, 5,5));//7

	MyNL.Add(GetNormal(VL[1]-VL[0], VL[2]-VL[0]));//n0  In
	MyNL.Add(GetNormal(VL[6]-VL[5], VL[7]-VL[5]));//n1  Out
	MyNL.Add(GetNormal(VL[5]-VL[4], VL[1]-VL[4]));//n2  Up
	MyNL.Add(GetNormal(VL[2]-VL[6], VL[3]-VL[6]));//n3  Down
	MyNL.Add(GetNormal(VL[4]-VL[6], VL[0]-VL[6]));//n4  Left
	MyNL.Add(GetNormal(VL[5]-VL[1], VL[7]-VL[1]));//n5  Right



	MyFL.Add(Face_t(0,1,2,0,2)); //v0,v1,v2,n,c
	MyFL.Add(Face_t(1,2,3,0,2)); //v0,v1,v2,n,c
	MyFL.Add(Face_t(4,5,6,1,2));
	MyFL.Add(Face_t(5,6,7,1,2));
	MyFL.Add(Face_t(4,5,1,2,2));
	MyFL.Add(Face_t(0,1,4,2,2));
	MyFL.Add(Face_t(6,7,2,3,2));
	MyFL.Add(Face_t(7,2,3,3,2));
	MyFL.Add(Face_t(4,6,0,4,2));
	MyFL.Add(Face_t(0,6,2,4,2));
	MyFL.Add(Face_t(1,5,7,5,2));
	MyFL.Add(Face_t(1,3,7,5,2));





	MyFS3DE->ScreenSpace->Camera =&Observer;

	do{
		MyFS3DE->ClearOutput();

		x_rect_fill(0,0,ScrnPhysicalPixelWidth, ScrnPhysicalHeight,
								LogicalScr,0);
		My3DObj.AddToScreenSpaceAt(ObjPos);

		Sky->Draw(LogicalScr);
		MyFS3DE->Draw();

		x_wait_vsync();
		PageFlip();
		if(kbhit()){
			ch=getch();
			switch (ch) {
				case '+' : Observer.Pos=Observer.Pos+point_t( 0, 0, 50); break;
				case '-' : Observer.Pos=Observer.Pos-point_t( 0, 0, 50); break;
				case '1' : Observer.Pos=Observer.Pos-point_t( 5, 0, 0); break;
				case '3' : Observer.Pos=Observer.Pos+point_t( 5, 0, 0); break;
				case '8' : ObjPos.Rot.Rotate(0, 5); break;
				case '2' : ObjPos.Rot.Rotate(0,-5); break;
				case '6' : ObjPos.Rot.Rotate(1, 5); break;
				case '4' : ObjPos.Rot.Rotate(1,-5); break;
				case '9' : ObjPos.Rot.Rotate(2, 5); break;
				case '7' : ObjPos.Rot.Rotate(2,-5); break;
				case '5' :  break;

				//case ' ' : break;
				//case ' ' : break;

			}
		}else ch=0;
		ObjPos.Rot.Rotate(0,1);  ObjPos.Rot.Rotate(1,1); ObjPos.Rot.Rotate(2,1);
		Observer.Pos=Observer.Pos+point_t(0,0,-0.1)*(point_t(0,0,1)*(Observer.Pos-ObjPos.Pos)+30);

	}while(ch!=27);
}
